package model;

//Rectangle.java

//Class that models a simple rectangle with dimensions width and height

public class Rectangle {

    //--------------------------------------------------------------
    //Instance Variables

	private int width;
	private int height;

    //--------------------------------------------------------------
    //Public Constructors

    //Returns new Rectangle with width and height set to zero.
	public static Rectangle newRectangle() {
        return Rectangle.fromWidthHeight(0, 0);
    }

    //Returns new Rectangle that is a square with width and height both
    //set to method param "aSide"
    public static Rectangle fromSide(int aSide) {
        return Rectangle.fromWidthHeight(aSide, aSide);
    }

    //Returns new Rectangle with width and height set to passed method params
    public static Rectangle fromWidthHeight(int aWidth, int aHeight) {
        return new Rectangle(aWidth, aHeight);
    }

    //--------------------------------------------------------------
    //Private (Classic) Constructors

    //Classic constructor that accepts width and height params
    protected Rectangle(int aWidth, int aHeight) {
        this.width = aWidth;
        this.height = aHeight;
    }

	//---------------------------------------
    //Public Instance Methods

	//Compute and return the rectangle perimeter
	//perimeter = 2 * (width + height)
	public int getPerimeter() {
		return 2 * (this.width + this.height);
	}

}